<template>
  <q-page class="row justify-center items-center bg-light-blue-3">
    <q-card class="shadow-24 q-ma-lg" style="border-radius: 15px; width: 50%">
      <div class="text-center q-pt-lg">
        <q-img src="../assets/logo.png" height="auto" width="80px" />
        <h5 class="text-black text-bold" style="margin-top: -1px">
          humbl<span class="text-red text-bold">x</span>
        </h5>
      </div>

      <q-form method="post" @submit="registerUser">
        <q-card-section>
          <q-input
            label="First Name *"
            v-model="firstName"
            lazy-rules
            :rules="[(val) => val !== null || 'First Name cannot be empty']"
          />
          <q-input
            label="Last Name *"
            v-model="lastName"
            lazy-rules
            :rules="[(val) => val !== null || 'Last Name cannot be empty']"
          />
          <q-input
            label="Email *"
            v-model="email"
            lazy-rules
            :rules="[(val) => val !== null || 'Email cannot be empty']"
          />

          <q-input
            label="Password *"
            v-model="password"
            lazy-rules
            :rules="[(val) => val !== null || 'Password cannot be empty']"
            :type="isPwd ? 'password' : 'text'"
          >
            <template v-slot:append>
              <q-icon
                :name="isPwd ? 'visibility_off' : 'visibility'"
                @click="isPwd = !isPwd"
              />
            </template>
          </q-input>
          <q-input
            label="Confirm Password *"
            v-model="confirmPassword"
            lazy-rules
            :rules="[
              (val) => val !== null || 'Confirm Password cannot be empty',
            ]"
            :type="isConfirm ? 'Password' : 'text'"
          >
            <template v-slot:append>
              <q-icon
                :name="isConfirm ? 'visibility_off' : 'visibility'"
                @click="isConfirm = !isConfirm"
              />
            </template>
          </q-input>
        </q-card-section>

        <q-card-actions class="q-ma-sm">
        <div class="col-10">
          Already have an account ? <a href="/login"> Log In </a>
        </div>
        <q-btn class="glossy" rounded color="deep-orange" label="REGISTER" type="submit" />
      </q-card-actions>
      </q-form>
    </q-card>
  </q-page>
</template>

<script>
import { api } from "boot/axios";
export default {
  name: "RegisterUser",
  data() {
    return {
      firstName: "",
      lastName: "",
      email: "",
      password: "",
      confirmPassword: "",
      isPwd: true,
      isConfirm: true,
    };
  },

  methods: {
      registerUser: function () {
          if(this.password !== this.confirmPassword){
              this.$q.notify({
            title: "Failed",
            color: 'red-5',
            textColor: 'white',
            icon: 'warning',
            message: "Error : Password should be same."
            })
          }
        else{
      this.newUser = {
        firstName: this.firstName,
        lastName: this.lastName,
        email: this.email,
        password: this.password
      };
    
      api.post("/registerUser", {
        data: this.newUser
      })
      .then((response) => {
        if (response.data.ok === true) {
          this.$q.notify({
            title: "Success",
            color: 'green-4',
            textColor: 'white',
            icon: 'cloud_done',
            message: "Register successfully. you can Login now."
          })
          this.$router.push('/login') 
        } else {
          this.$q.notify({
            title: "Failed",
            color: 'red-5',
            textColor: 'white',
            icon: 'warning',
            message: "Error : " + response.data.error
          });
        }
      });
    }
    },
  },
};
</script>
